package tomcat_jk.servlet;

import java.io.PrintWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Vector;
import java.util.Hashtable;
import javax.servlet.ServletContext;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletException;

/**
 * 
 * 
 * @author Osamu Hashimoto osm@yha.att.ne.jp
 *
*/

public class SearchServlet extends HttpServlet {

	Connection conn;
	String dbUrl = "jdbc:postgresql://localhost:5432/customer";
	String dbId	 = "tomcat_jk";
	String dbPwd = "tomcat_jk";
	String msg	 = "ȂB";
	boolean bDebugOn = false;
	
	/**
	 *
	 * T[ubg̋NɂP񂾂s܂B
	 *
	 * @param Ȃ
	 *
	*/
	public void init() {
		
		try {
			Class.forName( "org.postgresql.Driver" );
		} catch( ClassNotFoundException ex ) {
			ex.printStackTrace();
			this.msg = ex.getMessage();
		}
	}
	
	/**
	 *
	 * F؉ʂR[ꂽۂ̏s܂(̃C)B
	 * 
	 * @param HttpServletRequest  request
	 * @param HttpServletResponse response
	 *
	*/
	public void 
		doPost( HttpServletRequest request, HttpServletResponse response ) {
		
		HttpSession session = request.getSession();
		if ( session.isNew() || request.getParameter( "id" ) == null ) {
			try {
				response.sendRedirect( "/tomcat_jk/Login.jsp" );
				return;
			} catch ( IOException ex ) {
				ex.printStackTrace();
				this.msg = ex.getMessage();
			}
		}
		
		String level  = ( String )session.getAttribute( "level" );
		if ( bDebugOn )System.out.println( "SearchServlet : level = " + level );
		request.setAttribute( "level", level );
		String accId  = request.getParameter( "id" );
		if ( bDebugOn ) System.out.println( "request.getParameter( \"id\" ) : " + request.getParameter( "id" ) );
		request.setAttribute( "accId", accId );
		
		try {
			conn = DriverManager.getConnection( dbUrl, dbId, dbPwd );
		} catch( SQLException ex ) {
			ex.printStackTrace();
			this.msg = ex.getMessage();
		}

		String sqlStatement = "select * from customer";
		
		
		Vector searchResult = new Vector();
		searchResult = this.searchDatabase( sqlStatement );
		
		response.setContentType( "text/html; charset=Shift_JIS" );
		request.setAttribute( "hitResults", searchResult );
		request.setAttribute( "message", this.msg );
		
		if ( !bDebugOn ) {
			try {
				ServletContext sc = getServletContext();
				RequestDispatcher rd = sc.getRequestDispatcher( "/SearchResult.jsp" );
				rd.forward( request, response );
			} catch ( ServletException ex ) {
				ex.printStackTrace();
				this.msg = ex.getMessage();
			} catch ( IOException ex ) {
				ex.printStackTrace();
				this.msg = ex.getMessage();
			}
		} else {
			displayResult( response, searchResult );
		}
		
		try {
			conn.close();
		} catch( SQLException ex ) {
			ex.printStackTrace();
			ex.getMessage();
		}
		
		conn = null;
		System.out.println( "NO : " + this.msg );
	}
	
	/**
	 *
	 * ServletURL𒼐ڃLbNꂽۂɁAdoPost() ɐU܂B
	 * 
	 * @param HttpServletRequest  request
	 * @param HttpServletResponse response
	 *
	*/
	public void doGet( HttpServletRequest request, HttpServletResponse response ) {
		doPost( request, response );
	}
	
	/**
	 *
	 * DBs܂B
	 * 
	 * @param String sqlStatement
	 *
	*/
	private Vector searchDatabase( String sqlStatement ) {
	
		Vector vResult = new Vector();
		ResultSet rResult = null;
		try {
			Statement stmt = conn.createStatement();
			rResult = stmt.executeQuery( sqlStatement );
			vResult = this.setResult( rResult );
			rResult.close();
		} catch ( SQLException ex ) {
			ex.printStackTrace();
			this.msg = ex.getMessage();
		} finally {
			
			rResult = null;
		}
		
		return vResult;
	}
	
	/**
	 *
	 * DBʂ̊i[s܂B
	 * 
	 * @param ResultSet rResult
	 *
	*/
	private Vector setResult( ResultSet rResult ) {
		Vector vResult = new Vector();
		try {
			while( rResult.next() ) {
				try {
					Hashtable htRow = new Hashtable();
					htRow.put( "level", new Integer( rResult.getInt( "Account_Level" ) ) );
					htRow.put( "sex",        rResult.getString( "sex" )        );
					htRow.put( "age",        rResult.getString( "age" )        );
					htRow.put( "name",       rResult.getString( "name" )       );
					htRow.put( "name_jp",    rResult.getString( "name_jp" )    );
					htRow.put( "job",        rResult.getString( "job" )        );
					htRow.put( "company",    rResult.getString( "job" )        );
					htRow.put( "company",    rResult.getString( "company" )    );
					htRow.put( "dept",       rResult.getString( "dept" )       );
					htRow.put( "yakushoku",  rResult.getString( "yakushoku" )  );
					htRow.put( "e_mail",     rResult.getString( "e_mail" )     );
					htRow.put( "pref",       rResult.getString( "pref" )       );
					htRow.put( "address",    rResult.getString( "address" )    );
					htRow.put( "phone",      rResult.getString( "phone" )      );
					htRow.put( "cell_phone", rResult.getString( "cell_phone" ) );
					
					htRow.put( "memo", rResult.getString( "memo" ) );
					
					vResult.addElement( htRow );
					
				} catch ( NullPointerException ex ) {
					ex.printStackTrace();
					this.msg = ex.getMessage();
				}
			}
		} catch ( SQLException ex ) {
			ex.printStackTrace();
			this.msg = ex.getMessage();
		}
		return vResult;
	}
	
	
	/**
	 *
	 * fobÔ߂̃\bhłB
	 * 
	 * @param ResultSet rResult
	 * @param Vector hitResults
	 *
	*/
	private void displayResult( HttpServletResponse response, Vector hitResults ) {
	
		if ( bDebugOn == true ) {
			
			try {
			
				PrintWriter out = response.getWriter();
				
				if ( !this.msg.equals( "ȂB" ) ) {
					out.println( "<html><head><title>G[bZ[W</title></head>" );
					out.println( "<body><h1>" + this.msg + "</h1></body></html>" );
					return;
				}
				
				out.println( "hitResults.size() = " + hitResults.size() );
				
				out.println( "<table border=1>" );
				for ( int i = 0; i < hitResults.size(); i++ ) {
					out.println( "<tr>" );
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "sex" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "age" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "name" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "name_jp" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "company" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "dept" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "yakushoku" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "e_mail" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "pref" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "address" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "phone" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "cell_phone" ) + "</td>");
					out.println( "<td>" + ( ( Hashtable )hitResults.get( i ) ).get( "memo" ) + "</td>");
					out.println( "</tr>" );
				}
				out.println( "</table>" );
			
			} catch ( IOException ex ) {

				ex.printStackTrace();
				this.msg = ex.getMessage();
			}
			
		}
	}

	/**
	 * T[ubg̃A[h1񂾂s܂B
	 *
	 * @param ȂB
	*/
	public void destroy() {
		// JDBC\[X̊JȂǂłȂꍇAɏ܂B
		// LłȂꍇATCg傫Ȃ邲ƂDB̃vZXȂA
		// [ȖƂȂ肩˂܂B
		// CĂB
	}
}
